<template>
  <div>
    <Tester
      v-if="testBaseInfo"
      :baseInfo="testBaseInfo"
      v-bind="{ question, testStatus, curQuestionNumber }"
      @start="loadTestConfig"
      @send-answer="onSendAnswer"
    />
  </div>
</template>
<script>
import Tester from "@/components/Base/Tester.vue";
import { mapActions, mapState } from "vuex";

export default {
  components: {
    Tester
  },
  data() {
    return {
      testId: this.$route.params.id,
      testStatus: null,
    };
  },
  computed: {
    ...mapState("user", {
      user: state => state
    }),
    ...mapState("student", ["testBaseInfo", "test"]),
    ...mapState("tester", ["question", "curQuestionNumber", "ended"]),
  },
  watch: {
    ended(v) {
      if (v) {
        this.testStatus = 'finished';
      }
    }
  },
  methods: {
    ...mapActions(['setMessage']),
    ...mapActions("student", ["getTest", "startTest", "loadNextQuestion", "sendAnswer"]),
    async loadTestConfig(e) {
      const res = await this.startTest({
        testId: this.testId,
        group: e.group // Сюда надо впихнуть выбранную из списка группу
      });

      if (!res.error) {
        this.testStatus = 'in_progress'
      }
    },
    async onSendAnswer(e) {
      const { resultId } = this.testBaseInfo;
      const res = await this.sendAnswer({ ...e, resultId });

      if (!res.err) {
        this.setMessageText({
          text: 'Вы успешно отправили вопрос!',
          type: 'success',
        });

      }
    },
  },
  async mounted() {
    const res = await this.getTest({
      testId: this.testId
    });

    this.testStatus = res.answer.status;

    if (this.testStatus === 'in_progress') {
      await this.loadNextQuestion({ resultId: res.answer.resultId });
    }
  }
};
</script>